## maas 1.8.3+bzr4053

=== Makefile ===
python := python2.7

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
virtualenv := virtualenv
else
buildout := bin/buildout buildout:offline=true
virtualenv := virtualenv --never-download
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js

# MAAS SASS stylesheets. The first input file (maas-styles.css) imports
# the others, so is treated specially in the target definitions.
scss_inputs := \
    src/maasserver/static/scss/maas-styles.scss \
    $(wildcard src/maasserver/static/scss/*/*.scss) \
    $(wildcard src/maasserver/static/scss/*/*/*.scss)
scss_output := src/maasserver/static/css/maas-styles.css

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

# For anything we start, we want to hint as to its root directory.
export MAAS_ROOT := $(CURDIR)/run

build: \
    bin/buildout \
    bin/database \
    bin/maas \
    bin/maas-probe-dhcp \
    bin/maas-provision \
    bin/maas-region-admin \
    bin/twistd.cluster \
    bin/twistd.region \
    bin/test.cli \
    bin/test.cluster \
    bin/test.config \
    bin/test.e2e \
    bin/test.js \
    bin/test.region \
    bin/test.testing \
    bin/py bin/ipy \
    $(js_enums)

all: build doc

release_codename := $(shell lsb_release -c -s)

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    --no-install-recommends install $(shell sort -u \
	        $(addprefix required-packages/,base build dev doc $(release_codename)))
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    purge $(shell sort -u required-packages/forbidden)

.gitignore: .bzrignore
	sed 's:^[.]/:/:' $^ > $@
	echo '/src/**/*.pyc' >> $@
	echo '/etc/**/*.pyc' >> $@

bin/python:
	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)
	bin/pip install hypothesis==0.7.2  # buildout can't install this.

configure-buildout:
	utilities/configure-buildout

bin/buildout: bin/python bootstrap/zc.buildout-1.5.2.tar.gz
	@utilities/configure-buildout --quiet
	bin/python -m pip --quiet install --ignore-installed \
	    --no-dependencies bootstrap/zc.buildout-1.5.2.tar.gz
	$(RM) README.txt  # zc.buildout installs an annoying README.txt.
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas-region-admin bin/twistd.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region
	@touch --no-create $@

bin/test.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region-test
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cli
	@touch --no-create $@

bin/test.cli: bin/buildout buildout.cfg versions.cfg setup.py bin/maas
	$(buildout) install cli-test
	@touch --no-create $@

bin/test.js: bin/karma bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install js-test
	@touch --no-create $@

bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install e2e-test
	@touch --no-create $@

bin/test.testing: \
	bin/buildout bin/sass buildout.cfg versions.cfg setup.py
	$(buildout) install testing-test
	@touch --no-create $@

bin/maas-probe-dhcp bin/maas-provision bin/twistd.cluster: \
    bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cluster
	@touch --no-create $@

bin/test.cluster: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cluster-test
	@touch --no-create $@

bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install config-test
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/rst-lint: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install rst-lint
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

define karma-deps
  karma@0.12.32
  karma-chrome-launcher@0.1.12
  karma-firefox-launcher@0.1.6
  karma-jasmine@0.3.5
  karma-opera-launcher@0.1.0
  karma-phantomjs-launcher@0.1.4
  karma-failed-reporter@0.0.3
endef

bin/karma: deps = $(strip $(karma-deps))
bin/karma: prefix = include/nodejs
bin/karma:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) $(deps)
	@ln -srf $(prefix)/node_modules/karma/bin/karma $@

bin/protractor: prefix = include/nodejs
bin/protractor:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) protractor@2.0.0
	@ln -srf $(prefix)/node_modules/protractor/bin/protractor $@

bin/sass: prefix = include/nodejs
bin/sass:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) node-sass@3.1.0
	@ln -srf $(prefix)/node_modules/node-sass/bin/node-sass $@

test: test-scripts-all = $(wildcard bin/test.*)
# Don't run bin/test.e2e for now; it breaks.
test: test-scripts = $(filter-out bin/test.e2e,$(test-scripts-all))
test: build
	@$(RM) coverage.data
	@echo $(test-scripts) | xargs --verbose -n1 env

test+coverage: export NOSE_WITH_COVERAGE = 1
test+coverage: test

coverage-report: coverage/index.html
	sensible-browser $< > /dev/null 2>&1 &

coverage.xml: coverage.data
	python-coverage xml --include 'src/*' -o $@

coverage/index.html: coverage.data
	@$(RM) -r $(@D)
	python-coverage html --include 'src/*' -d $(@D)

coverage.data:
	@$(error Use `$(MAKE) test` to generate coverage data, or invoke a \
            test script using the `--with-coverage` flag)

lint: lint-py lint-js lint-doc lint-rst

pocketlint = $(call available,pocketlint,python-pocket-lint)

# XXX jtv 2014-02-25: Clean up this lint, then make it part of "make lint".
lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

# Python lint checks are time-intensive, so we run them in parallel.  It may
# make things matters worse if the files need to be read from disk, though, so
# this may need more tuning.
# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
# all the files in cache.
lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
lint-py: bin/flake8
	@find $(sources) -name '*.py' ! -path '*/migrations/*' -print0 \
	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123 --config=/dev/null
	@utilities/check-maaslog-exception

lint-doc:
	@utilities/doc-lint

# lint-rst 0.11.1 shouldn't be used on our documentation because it
# doesn't understand Sphinx's extensions, and doesn't grok linking
# between documents, hence complaints about broken links. However,
# Sphinx itself warns about lint when building the docs.
lint-rst: sources = README HACKING.txt schema/README.rst
lint-rst: bin/rst-lint
	@find $(sources) -type f \
	    -printf 'Linting %p...\n' \
	    -exec bin/rst-lint --encoding=utf8 {} \;

# JavaScript lint is checked in parallel for speed.  The -n20 -P4 seetting
# worked well on a multicore SSD machine with the files cached, roughly
# doubling the speed, but it may need tuning for slower systems or cold caches.
lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f ! -path '*/angular/3rdparty/*' -print0 '(' -name '*.html' -o -name '*.js' ')' \
		| xargs -r0 -n20 -P4 $(pocketlint)

# Apply automated formatting to all Python files.
format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
format:
	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports

check: clean test

docs/api.rst: bin/maas-region-admin src/maasserver/api/doc_handler.py syncdb
	bin/maas-region-admin generate_api_doc > $@

sampledata: bin/maas-region-admin bin/database syncdb
	$(dbrun) bin/maas-region-admin loaddata src/maasserver/fixtures/dev_fixture.yaml

doc: bin/sphinx docs/api.rst
	bin/sphinx

doc-with-versions: bin/sphinx docs/api.rst
	cd docs/_build; make SPHINXOPTS="-A add_version_switcher=true" html

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@

styles: bin/sass clean-styles $(scss_output)

$(scss_output): $(scss_inputs)
	bin/sass --include-path=src/maasserver/static/scss --output-style compressed $< -o $(dir $@)

clean-styles:
	$(RM) $(scss_output)

clean: stop
	$(MAKE) -C acceptance $@
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums)
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees
	$(RM) coverage.data coverage.xml
	$(RM) -r coverage
	$(RM) -r bin include lib local
	$(RM) -r eggs develop-eggs
	$(RM) -r build dist logs/* parts
	$(RM) tags TAGS .installed.cfg
	$(RM) -r *.egg *.egg-info src/*.egg-info
	$(RM) -r run/* run-e2e/* services/*/supervise

clean+db: clean
	$(RM) -r db

distclean: clean
	$(warning 'distclean' is deprecated; use 'clean')

harness: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin shell --settings=maas.demo

dbharness: bin/database
	bin/database --preserve shell

syncdb: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin syncdb --noinput
	$(dbrun) bin/maas-region-admin migrate maasserver --noinput
	$(dbrun) bin/maas-region-admin migrate metadataserver --noinput

# (Re)write the baseline schema.
schema/baseline.sql: bin/database
	$(dbrun) pg_dump -h $(PWD)/db/ -d maas --no-owner --no-privileges -f $@

# Synchronise the database, and update the baseline schema.
baseline-schema: syncdb schema/baseline.sql

define phony_targets
  build
  check
  clean
  clean-styles
  clean+db
  configure-buildout
  coverage-report
  dbharness
  distclean
  doc
  enums
  format
  harness
  install-dependencies
  lint
  lint-css
  lint-doc
  lint-js
  lint-py
  lint-rst
  man
  package
  package-clean
  package-dev
  package-dev-clean
  sampledata
  source_package
  styles
  syncdb
  test
  test+coverage
endef

#
# Development services.
#

service_names_region := database dns regiond regiond2 reloader
service_names_cluster := clusterd reloader
service_names_all := $(service_names_region) $(service_names_cluster)

# The following template is intended to be used with `call`, and it
# accepts a single argument: a target name. The target name must
# correspond to a service action (see "Pseudo-magic targets" below).
# A region- and cluster-specific variant of the target will be
# created, in addition to the target itself. These can be used to
# apply the service action to the region services, the cluster
# services, or all services, at the same time.
define service_template
$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))

=== debian/changelog ===
maas (1.8.3+bzr4053-0ubuntu1) wily; urgency=medium

  * New upstream release, 1.8.3 bzr 4053:
    - Declare dependency on metadataserver migration 0015 by maasserver
      migration 0121 to allow upgrades from 1.5.4 to 1.8 to work. (LP: #1495064)
    - Fix the issue where the included ':', apache2 wont forward the
      connection (LP: #1484696)
    - Fixes autocomplete styling for tagging (LP: #1489160)
    - Add HPDSA hardware drivers to the drivers config (LP: #1491898)
    - Always invoke the init system using the C.UTF-8 locale. (LP: #1491822)
    - Use cluster_name instead of name for the cluster, otherwise the UI
      will show the DNS zone name instead of the actual cluster name.
    - Fix twisted related Internal Server Error when IPv6 addresses present
      in wily. (LP: #1504971)
  * debian/control: Restart maas-clusterd in the event it failed to start
    due to missing /var/lib/maas/secret (LP: #1471946) 

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 08 Oct 2015 21:53:04 -0700

maas (1.8.2+bzr4041-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.2 bzr 4041:
    - Regenerate the connection URL on websocket client reconnect, to fix
      CSRF after upgrade to 1.8.1. (LP: #1484696)
    - Validate the osystem and distro_series when using the deploy action,
      which fixes win2012r2 deployment issues. (LP: #1445942)
    - Fix failure in MAAS startup messages by not generating dhcpd config
      files when they are not in use. (LP: #1481940)
    - Fix enlistment to always use the correct kernel parameters. (LP: #1459865)
  * debian/control: Add missing dep on python-curtin.
  * debian/maas-cluster-controller.postinst: Drop mangling of apache2.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 17 Aug 2015 11:31:20 +0100

maas (1.8.1+bzr4036-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.1 bzr4036:
    - Add --username to maas-region-admin apikey command
      docs. (LP: ##1481118)
    - Add ListBootImagesV2 RPC command; fallback to using ListBootImages
      when the ListBootImagesV2 is not handled on the cluster.
    - Fix setting the default_distro_series over the API (LP: #1470591)
    - Fix upgrade issue where it would remove custom DNS config,
      potentially breaking DNS (LP: #1413388)
    - Commissioning x86_64 node never completes, sitting at grub
      prompt, pserv py tbs (LP: #1317705)
    - Power monitor service hits amp.TooLong errors with > ~600
      nodes to a cluster (LP: #1389007)
    - Websocket server accessed over port 5240 (LP: #1436279)
    - If hostname not set, sudo warning make maas throw 500 (LP: #1469305)    
    - Can't set a list of forwarders (BIND config) (LP: #1470585)
    - UCS chassis enlist Failed to probe and enlist UCS nodes: list
      index out of range (LP: #1469846)
    - Add cisco snic to 3rd party driver (LP: #1470276)
    - console= parameters need to be added before -- on kernel
      cmdline (LP: #1402042)
    - [UI] Machine details styling (LP: #1465722)
    - [UI] Actions design styles (LP: #1465737)
    - [UI] Replace close "X" with correct versions (LP: #1465740)
    - [UI] Table design styles (LP: #1465742)
    - [UI] Make table heading hover consistant with nodes/devices
      tabs (LP: #1470389)
    - [UI] adding between node name and save button
      inconsistent (LP: #1470395)
    - [UI] "Set zone" label oddly placed on node listing
      page (LP: #1459710)

  [ Raphaël Badin ]
  * Enable proxy_wstunnel module.
  * Drop dependency on python-iscpy: the code has been integrated into
    MAAS. (LP: #1413388).

  [ Andres Rodriguez ]
  * Refactor maas-dns upgrade code so it doesn't break local DNS config
    and it gets migrated (LP: #1413388)
    - debian/maas-region-controller.postinst: Ensure DNS config migration
      is always run.
  * debian/control: Make maas-dns a Dependy of maas-region-controller.

  [ Scott Moser ]
  * maas-proxy: sync white space changes with trunk packaging branch
  * maas-proxy: sync apt specific squid config with squid-deb-proxy
    (LP: #1474417)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 06 Jul 2015 23:52:59 -0400

maas (1.8.0+bzr4001-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 09 Jun 2015 20:57:42 -0400

maas (1.8.0~rc3+bzr4000-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC3 bzr4000.

  [ Raphaël Badin ]
  * Remove unused dependencies: python-amqp and python-txamqp.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 04 Jun 2015 16:32:02 -0400

maas (1.8.0~rc2+bzr3989-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC2 bzr3983.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 02 Jun 2015 09:27:54 -0400

maas (1.8.0~rc1+bzr3972-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC1 bzr3972.
  * debian/copyright: Add copyright headers for ng-tags-input.js.
  * debian/control: Bump Standards-Version

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 May 2015 20:16:40 -0400

maas (1.8.0~beta8+bzr3951-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 beta 8 bzr3951.

  [ Raphaël Badin ]
  * debian/extras/99-maas-sudoers: Allow maas to check the status of
    maas-dhcpd and maas-dhcp6 and start these services (LP: #1457708).

  [ Andres Rodriguez ]
  * debian/rules: Ensure maas-regiond-worker is not started in packaging.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 21 May 2015 19:18:22 -0400

maas (1.8.0~beta7+bzr3926-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 beta 7 bzr3926.

  [ Andres Rodriguez ]
  * debian/{maas-cluster-controller,maas-common,
    maas-region-controller-min}.postinst: Cleaned up to correctly create
    log dir permissions (LP: #1457191)

  [ Gavin Panella ]
  * Create maas-regiond workers for systemd.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 May 2015 17:03:13 -0400

maas (1.8.0~beta6+bzr3891-0ubuntu1) trusty; urgency=medium



=== debian/control ===
Source: maas
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.1.0~),
               dh-apport,
               dh-systemd,
               po-debconf,
               python (>= 2.7),
               python-distribute,
               python-django
Standards-Version: 3.9.6
X-Python-Version: >= 2.7
Homepage: https://launchpad.net/maas

Package: maas
Architecture: all
Depends: ${misc:Depends},
 maas-cluster-controller (= ${binary:Version}),
 maas-region-controller (= ${binary:Version}),
 python-django-maas (= ${binary:Version})
Description: MAAS server all-in-one metapackage
 MAAS is "Metal As A Service", a system for dynamic provisioning of physical
 servers that has many of the same characteristics as a cloud.  You register
 servers with MAAS by telling MAAS about their IPMI or other control system.
 MAAS can then do hardware inventory, and provision that system on demand
 with whatever OS and software you like.  MAAS is standalone software that
 works with any configuration system, but for best results combine MAAS with
 Juju.
 .
 MAAS provides:
  * Hardware inventory of servers
  * Dynamic provisioning based on name or attributes such as disk, RAM cores, sockets
  * DNS and DHCP as needed
  * PXE boot services
 .
 This package is a metapackage which installs all of the separate components
 of MAAS on a single machine.

Package: maas-common
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: MAAS server common files
 This package contains the common files for any MAAS installation.

Package: maas-region-controller-min
Architecture: all
Depends: apache2,
         bind9utils,
         dbconfig-common,
         iproute,
         libjs-angularjs,
         libjs-yui3-full,
         libjs-yui3-min,
         maas-common (= ${binary:Version}),
         maas-proxy (= ${binary:Version}),
         python-bson,
         python-django16 | python-django (<< 1.7),
         python-django,
         python-django-maas (= ${binary:Version}),
         python-django-piston,
         python-django-south,
         python-maas-provisioningserver (= ${binary:Version}),
         python-djorm-ext-pgarray,
         rsyslog,
         ubuntu-cloudimage-keyring,
         ${misc:Depends},
         ${python:Depends}
Breaks: maas-region-controller ( <= 1.4+bzr1693+dfsg-0ubuntu3 )
Replaces: maas-region-controller ( <= 1.4+bzr1693+dfsg-0ubuntu3 )
Description: MAAS Server minimum region controller
 This package installs and configures the minimum region controller
 services provided by MAAS, including the web UI, caching package proxy,
 networking/traffic control, and remote logging system.

Package: maas-region-controller
Architecture: all
Depends: maas-dns (= ${binary:Version}),
         maas-region-controller-min (= ${binary:Version}),
         postgresql (>= 9.1),
         ${misc:Depends},
         ${python:Depends}
Recommends: openssh-server
Description: MAAS server complete region controller
 This package installs and configures the complete MAAS region controller,
 including the minimum setup, plus the database server and messaging queue.

Package: python-maas-provisioningserver
Section: python
Architecture: all
Depends: python-bson,
         python-crochet,
         python-curtin,
         python-distro-info,
         python-formencode,
         python-jsonschema,
         python-lockfile,
         python-lxml,
         python-maas-client (= ${binary:Version}),
         python-netifaces,
         python-paramiko,
         python-pexpect,
         python-pyparsing,
         python-seamicroclient,
         python-simplestreams,
         python-tempita,
         python-twisted-core,
         python-twisted-web,
         python-txtftp,
         python-yaml,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Breaks: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3), maas-dhcp (<= 1.4+bzr1817+dfsg-0ubuntu1)
Replaces: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3), maas-dhcp (<= 1.4+bzr1817+dfsg-0ubuntu1)
Description: MAAS server provisioning libraries
 This package provides the MAAS provisioning server python libraries.

Package: maas-cli
Architecture: all
Depends: python-bzrlib,
         python-httplib2,
         python-maas-client (= ${binary:Version}),
         python-oauth,
         ${misc:Depends},
         ${python:Depends}
Conflicts: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Replaces: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Description: MAAS command line API tool
 This package contains the MAAS client command line API tool.
 This tool enables automation of tasks in MAAS, remotely, through
 its API.

Package: python-maas-client
Section: python
Architecture: all
Depends: python-oauth, ${misc:Depends}, ${python:Depends}
Breaks: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Replaces: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Description: MAAS python API client
 This package contains the MAAS client API Python modules.

Package: maas-cluster-controller
Architecture: all
Depends: authbind,
         bind9utils,
         distro-info,
         freeipmi-tools,
         grub-common,
         maas-cli (=${binary:Version}),
         maas-common (=${binary:Version}),
         maas-dhcp (=${binary:Version}),
         python-httplib2,
         python-lockfile,
         python-maas-provisioningserver (=${binary:Version}),
         python-netaddr,
         python-oauth,
         python-tempita,
         python-twisted,
         python-zope.interface,
         rsyslog,
         pxelinux | syslinux-common (<< 3:6.00~pre4+dfsg-5),
         syslinux-common,
         tgt,
         uuid-runtime,
         wget,
         ${misc:Depends},
         ${python:Depends}
Suggests: ipmitool, libvirt-bin, amtterm, python-pyvmomi
Conflicts: tftpd-hpa
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Description: MAAS server cluster controller
 This package contains the MAAS cluster controller, which is responsible
 for enabling and controlling remote DHCP/TFTP instances on their own
 subnets.

Package: python-django-maas
Section: python
Architecture: all
Depends: python-apt,
         python-convoy,
         python-crochet,
         python-curtin,
         python-lockfile,
         python-lxml,
         python-maas-client (= ${binary:Version}),
         python-netaddr,
         python-psycopg2,
         python-sphinx,
         python-tempita,
         python-twisted,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Description: MAAS server Django web framework
 This package provides the Django web framework for MAAS.

Package: maas-dhcp
Architecture: all
Depends: isc-dhcp-server (>= 4.2.4), ${misc:Depends}
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: MAAS DHCP server
 This package installs and configures a DHCP server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-dns
Architecture: all
Depends: bind9,
 maas-region-controller-min (= ${binary:Version}),
 ${misc:Depends}
Conflicts: dnsmasq
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: MAAS DNS server
 This package installs and configures a DNS server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-proxy
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         squid3
Conflicts: squid-deb-proxy
Replaces: squid-deb-proxy
Description: MAAS Caching Proxy
 This package installs and configures a Caching Proxy server that can be
 used by MAAS. It enhances the overall MAAS user experience.

=== debian/rules ===
#!/usr/bin/make -f

BUILDHOME = $(CURDIR)/debian/build
PYTHON = $(shell pyversions -d)
# Python enum modules.
py_enums := $(wildcard src/*/enum.py)

%:
	dh $@ --with python2,apport,systemd --buildsystem=python_distutils

override_dh_installinit:
	# maas-clusterd
	dh_systemd_enable --name maas-clusterd
	dh_installinit --name maas-clusterd
	dh_systemd_start --name maas-clusterd
	# maas-regiond
	dh_systemd_enable --name maas-regiond
	dh_installinit --name maas-regiond
	dh_systemd_start --name maas-regiond
	# maas-regiond-worker
	dh_installinit --no-start --name maas-regiond-worker  # Upstart
	dh_installinit --no-start --name maas-regiond-worker@  # systemd
	# maas-dhcpd
	dh_systemd_enable --name maas-dhcpd
	dh_installinit --name maas-dhcpd
	dh_systemd_start --name maas-dhcpd
	# maas-dhcpd6
	dh_systemd_enable --name maas-dhcpd6
	dh_installinit --name maas-dhcpd6
	dh_systemd_start --name maas-dhcpd6
	# maas-proxy
	dh_systemd_enable --name maas-proxy
	dh_installinit --name maas-proxy
	dh_systemd_start --name maas-proxy

override_dh_auto_build:
	dh_auto_build

	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) PYTHONPATH=$(CURDIR)/src/ $(PYTHON)	\
		$(CURDIR)/src/maasserver/utils/jsenums.py	\
		$(py_enums) > $(BUILDHOME)/enums.js

override_dh_auto_install:
	dh_auto_install

	# Move static files
	install -d -m 755  $(CURDIR)/debian/tmp/usr/share/maas/web/static
	mv $(CURDIR)/debian/tmp/usr/lib/python*/*-packages/maasserver/static \
                $(CURDIR)/debian/tmp/usr/share/maas/web/

	# Remove scss directory from static files
	rm -rf $(CURDIR)/debian/tmp/usr/share/maas/web/scss

	# Install built enums.js file.
	cp $(BUILDHOME)/enums.js $(CURDIR)/debian/tmp/usr/share/maas/web/static/js/

	# install the apparmor profile
	install -d -m 755 $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d
	install -m 644 $(CURDIR)/debian/maas-dhcp.apparmor \
	    $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d/maas

	dh_install --list-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDHOME)
	rm -rf src/*.egg-info

DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
REV=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
get-orig-source:
	bzr export -r $(REV) --root=maas-$(VER).orig \
             maas_$(VER).orig.tar.gz lp:maas/1.8

## maas 1.9.5+bzr4599

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
 python := python2.7
+
+# pkg_resources makes some incredible noise about version numbers. They
+# are not indications of bugs in MAAS so we silence them everywhere.
+export PYTHONWARNINGS = \
+  ignore:You have iterated over the result:RuntimeWarning:pkg_resources:
 
 # Network activity can be suppressed by setting offline=true (or any
 # non-empty string) at the command-line.
@@ -63,7 +68,7 @@
 
 all: build doc
 
-release_codename := $(shell lsb_release -c -s)
+release_codename = $(shell lsb_release -c -s)
 
 # Install all packages required for MAAS development & operation on
 # the system. This may prompt for a password.
@@ -81,7 +86,6 @@
 
 bin/python:
 	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)
-	bin/pip install hypothesis==0.7.2  # buildout can't install this.
 
 configure-buildout:
 	utilities/configure-buildout
@@ -228,7 +232,8 @@
 lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
 lint-py: bin/flake8
 	@find $(sources) -name '*.py' ! -path '*/migrations/*' -print0 \
-	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123 --config=/dev/null
+	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123,E402,E731 \
+	    --config=/dev/null
 	@utilities/check-maaslog-exception
 
 lint-doc:
@@ -244,7 +249,7 @@
 	    -printf 'Linting %p...\n' \
 	    -exec bin/rst-lint --encoding=utf8 {} \;
 
-# JavaScript lint is checked in parallel for speed.  The -n20 -P4 seetting
+# JavaScript lint is checked in parallel for speed.  The -n20 -P4 setting
 # worked well on a multicore SSD machine with the files cached, roughly
 # doubling the speed, but it may need tuning for slower systems or cold caches.
 lint-js: sources = src/maasserver/static/js
@@ -257,6 +262,14 @@
 format:
 	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports
 
+# Update copyright dates from version history. Try to avoid updating
+# 3rd-party code by checking for "Canonical" or "MAAS" on the same line
+# as the copyright header.
+copyright:
+	@bzr ls --versioned --recursive --kind=file --null | \
+	    xargs -r0 egrep -iI 'copyright.*(canonical|maas)' -lZ | \
+	    xargs -r0 bzr update-copyright --quiet --force-range
+
 check: clean test
 
 docs/api.rst: bin/maas-region-admin src/maasserver/api/doc_handler.py syncdb
@@ -268,8 +281,13 @@
 doc: bin/sphinx docs/api.rst
 	bin/sphinx
 
+docs/_build/html/index.html: doc
+
+doc-browse: docs/_build/html/index.html
+	sensible-browser $< > /dev/null 2>&1 &
+
 doc-with-versions: bin/sphinx docs/api.rst
-	cd docs/_build; make SPHINXOPTS="-A add_version_switcher=true" html
+	$(MAKE) -C docs/_build SPHINXOPTS="-A add_version_switcher=true" html
 
 man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))
 
@@ -279,7 +297,7 @@
 enums: $(js_enums)
 
 $(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
-	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@
+	 bin/py -m maasserver/utils/jsenums $(py_enums) > $@
 
 styles: bin/sass clean-styles $(scss_output)
 
@@ -289,7 +307,7 @@
 clean-styles:
 	$(RM) $(scss_output)
 
-clean: stop
+clean: stop clean-run
 	$(MAKE) -C acceptance $@
 	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
 	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
@@ -302,15 +320,31 @@
 	$(RM) -r man/.doctrees
 	$(RM) coverage.data coverage.xml
 	$(RM) -r coverage
+	$(RM) -r .hypothesis
 	$(RM) -r bin include lib local
 	$(RM) -r eggs develop-eggs
 	$(RM) -r build dist logs/* parts
 	$(RM) tags TAGS .installed.cfg
 	$(RM) -r *.egg *.egg-info src/*.egg-info
-	$(RM) -r run/* run-e2e/* services/*/supervise
+	$(RM) -r services/*/supervise
+
+# Be selective about what to remove from run and run-e2e.
+define clean-run-template
+find $(1) -depth ! -type d \
+    ! -path $(1)/etc/maas/templates \
+    ! -path $(1)/etc/maas/drivers.yaml \
+    -print0 | xargs -r0 $(RM)
+find $(1) -depth -type d \
+    -print0 | xargs -r0 rmdir --ignore-fail-on-non-empty
+endef
+
+clean-run:
+	$(call clean-run-template,run)
+	$(call clean-run-template,run-e2e)
 
 clean+db: clean
 	$(RM) -r db
+	$(RM) .db.lock
 
 distclean: clean
 	$(warning 'distclean' is deprecated; use 'clean')
@@ -328,7 +362,7 @@
 
 # (Re)write the baseline schema.
 schema/baseline.sql: bin/database
-	$(dbrun) pg_dump -h $(PWD)/db/ -d maas --no-owner --no-privileges -f $@
+	$(dbrun) pg_dump -h $(CURDIR)/db -d maas --no-owner --no-privileges -f $@
 
 # Synchronise the database, and update the baseline schema.
 baseline-schema: syncdb schema/baseline.sql
@@ -337,51 +371,9 @@
   build
   check
   clean
+  clean+db
+  clean-run
   clean-styles
-  clean+db
   configure-buildout
+  copyright
   coverage-report
-  dbharness
-  distclean
-  doc
-  enums
-  format
-  harness
-  install-dependencies
-  lint
-  lint-css
-  lint-doc
-  lint-js
-  lint-py
-  lint-rst
-  man
-  package
-  package-clean
-  package-dev
-  package-dev-clean
-  sampledata
-  source_package
-  styles
-  syncdb
-  test
-  test+coverage
-endef
-
-#
-# Development services.
-#
-
-service_names_region := database dns regiond regiond2 reloader
-service_names_cluster := clusterd reloader
-service_names_all := $(service_names_region) $(service_names_cluster)
-
-# The following template is intended to be used with `call`, and it
-# accepts a single argument: a target name. The target name must
-# correspond to a service action (see "Pseudo-magic targets" below).
-# A region- and cluster-specific variant of the target will be
-# created, in addition to the target itself. These can be used to
-# apply the service action to the region services, the cluster
-# services, or all services, at the same time.
-define service_template
-$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
-$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))

=== acceptance/Makefile ===
#
# Build and test everything in ephemeral containers:
#
#   $ make
#
# Use a different packaging branch:
#
#   $ make packaging=/path/to/branch
#
# Note: /path/to/branch can be anything that bzr recognises, so an lp:
# link, or bzr+ssh, and so on.
#
# Build and test with a different Ubuntu series:
#
#   $ make series=randy
#

include /etc/lsb-release

# Default to the newer of Quantal or the local series.
series := $(lastword $(sort quantal $(DISTRIB_CODENAME)))

# Default to the main packaging branch on Launchpad, but treat Precise
# specially.
ifeq ($(series),precise)
packaging := lp:~maas-maintainers/maas/packaging.precise
else
packaging := lp:~maas-maintainers/maas/packaging
endif

# Assume we're testing this branch.
upstream := $(abspath ..)

# The container on which to base ephemerals.
container := maas-$(series)

## Convenience definitions.

define ephexec
sudo LC_ALL=C SSH_ASKPASS=$(abspath ubuntupass) setsid \
    lxc-start-ephemeral -b $(upstream) -o $(container) -u ubuntu -- \
    env DEBIAN_FRONTEND=noninteractive SUDO_ASKPASS=$(abspath ubuntupass)
endef

define ephexec-make
$(ephexec) $(abspath with-make) make -C $(abspath .)
endef

define check-service
test $(2) = $(wordlist 2,2,$(shell initctl --system status $(1)))  # $(1)
endef

## Top-level targets.

test: build | services sudo container-updated
	$(ephexec-make) $@-inner

# lxc-start-ephemeral does not return the exit code of any command it
# runs, so we delete any existing packages before building and check
# for their presence afterwards instead.
build: source source/debian | services sudo container
	@$(RM) *.deb
	$(ephexec-make) $@-inner
	@ls -1 *.deb
	@touch $@

container: | services sudo
	test -n "$$(sudo lxc-ls -1 $(container))" || \
	    sudo lxc-create -n $(container) -f /etc/lxc/default.conf \
	        -t ubuntu -- --release $(series)

container-updated: container | services sudo
	$(abspath update-container) $(container)

services:
	$(call check-service,lxc,start/running)
	$(call check-service,lxc-net,start/running)

define phony-outer-targets
  container
  container-updated
  services
  test
endef

## Targets that run within an LXC container.

# XXX: These packages appear to be missing from the dependencies
# declared in the packaging branch.
define missing-packages
  python-distribute
  python-django
endef

test-inner: upgrade-inner
	sudo -AE apt-get --assume-yes install $(strip $(missing-packages))
	sudo -AE dpkg --unpack --force-depends -- *.deb
	sudo -AE apt-get --fix-broken --assume-yes install

define build-packages
  debhelper
  devscripts
  dh-apport
endef

build-inner: | upgrade-inner
	sudo -AE apt-get --assume-yes install $(strip $(missing-packages))
	sudo -AE apt-get --assume-yes install $(strip $(build-packages))
	cd source && debuild -i -us -uc -b

upgrade-inner:
	sudo -AE apt-get --assume-yes update
	sudo -AE apt-get --assume-yes upgrade

define phony-inner-targets
  build-inner
  test-inner
  upgrade-inner
endef

## Dependencies.

source:
	bzr export --uncommitted $@ $(upstream)

source/debian: | source
	bzr export $@ $(packaging)/debian

## Miscellaneous.

sudo:
	@sudo -v

clean:
	$(RM) -r source build *.build *.changes *.deb

define phony-misc-targets
  clean
  sudo
endef

## Phony.

define phony
  $(phony-inner-targets)
  $(phony-misc-targets)
  $(phony-outer-targets)
endef

phony := $(sort $(strip $(phony)))

.PHONY: $(phony)

=== debian/changelog ===
maas (1.9.5+bzr4599-0ubuntu1~14.04.3) trusty-proposed; urgency=medium

  * Stable Release Update.
    - debian/patches/harcode-upstart-lp1732703.patch: Running snapd or
      livepatch in Trusty installs systemd. Due to a systemd regressions,
      this causes  MAAS to incorrectly detect the init system. As such,
      hardcode the init system to upstart (as systemd is not supported
      in Ubuntu) (LP: #1732703).

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 13 Dec 2017 18:09:11 -0500

maas (1.9.5+bzr4599-0ubuntu1~14.04.2) trusty-proposed; urgency=medium

  * Stable Release Update.
    - debian/patches/fix-shim-name-lp1713795.patch: Grub package in Trusty
      has changed the name of the shim and has caused MAAS to being unable
      to import new images. (LP: #1713795)
    - debian/control: Bump depends on grub-common to ensure latest is
      always installed.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 31 Aug 2017 15:22:08 -0400

maas (1.9.5+bzr4599-0ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * Stable Release Update. New MAAS upstream bugfix release 1.9.5 (LP: #1669591):
    - MAAS 1.9.5 is a new upstream bugfix release that fixes several bugs
      present on MAAS 1.9.4. This is solely a bugfix release. To see what
      issues this release fixes, please refer to the CHANGELOG
  * debian/control: Recommends bind9 (>= 1:9.9.5.dfsg-3ubuntu0.12~).

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 02 Mar 2017 16:58:13 -0500

maas (1.9.4+bzr4592-0ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * New Upstream Release, 1.9 (LP: #1509147):
    - Support for Advanced Networking and Node Network Configuration:
      + Ability to declare Fabrics, Spaces, Subnets, VLANs and FANs.
      + Ability to assign subnets, fabrics and IP's to node interfaces.
      + Ability to create VLAN interfaces for nodes.
      + Ability to create Bond interfaces for nodes.
      + Ability to create interface names.
    - Support for Advanced Storage Configuration.
      + Ability to configure LVM.
      + Ability to configure BCache.
      + Ability to configure Software RAID Levels 0, 1, 5, 6, 10.
      + Ability to perform advanced partitioning.
    - Support for Curtin & Cloud-init status reporting.
    - Minimal config files for maas-regiond and maas-clusterd.
    - Better support for Hardware Enablement Kernels (HWE).
    - Support for Commissioning Actions.
    - Warn users about missing power tools.
    - Switch away from shell scripts to Python Power Drivers.
    - CentOS images can now be imported.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 12 Jul 2016 21:34:23 -0400

maas (1.7.6+bzr3376-0ubuntu3~14.04.1) trusty-proposed; urgency=medium

  * debian/patches/lp1573046.patch: No longer use distro-info --lts to
    detect the commissioning release, as it returns 'xenial' for LTS.
    MAAS 1.7 only supports trusty. (LP: #1573046)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 09 May 2016 16:29:28 -0400

maas (1.7.6+bzr3376-0ubuntu2~14.04.1) trusty; urgency=medium

  * debian/control: Make maas-dns a Dependy of maas-region-controller.
  * debian/maas-region-controller.postinst: Ensure DNS config migration is
    always run. (LP: #1413388)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 10 Jul 2015 13:47:40 -0400

=== debian/control ===
--- 
+++ 
@@ -92,11 +92,10 @@
 Architecture: all
 Depends: python-bson,
          python-crochet,
-         python-curtin,
+         python-curtin (>= 0.1.0~bzr351),
          python-distro-info,
          python-formencode,
          python-jsonschema,
-         python-lockfile,
          python-lxml,
          python-maas-client (= ${binary:Version}),
          python-netifaces,
@@ -148,12 +147,11 @@
          bind9utils,
          distro-info,
          freeipmi-tools,
-         grub-common,
+         grub-common (>=  2.02~beta2-9ubuntu1.14),
          maas-cli (=${binary:Version}),
          maas-common (=${binary:Version}),
          maas-dhcp (=${binary:Version}),
          python-httplib2,
-         python-lockfile,
          python-maas-provisioningserver (=${binary:Version}),
          python-netaddr,
          python-oauth,
@@ -183,8 +181,7 @@
 Depends: python-apt,
          python-convoy,
          python-crochet,
-         python-curtin,
-         python-lockfile,
+         python-curtin (>> 0.1.0~bzr275),
          python-lxml,
          python-maas-client (= ${binary:Version}),
          python-netaddr,
@@ -212,6 +209,7 @@
 Depends: bind9,
  maas-region-controller-min (= ${binary:Version}),
  ${misc:Depends}
+Recommends: bind9 (>= 1:9.9.5.dfsg-3ubuntu0.12~)
 Conflicts: dnsmasq
 Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
 Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)

=== debian/rules ===
--- 
+++ 
@@ -74,4 +74,4 @@
               | sed -rne 's,^Version: ([^-]+).*,\1,p')
 get-orig-source:
 	bzr export -r $(REV) --root=maas-$(VER).orig \
-             maas_$(VER).orig.tar.gz lp:maas/1.8
+             maas_$(VER).orig.tar.gz lp:maas/1.9
